Subject: Re: Is it valid to add a macvlan virtual interface to a bridge? If so, there seems to be a bug with it.

From: Patrick McHardy <[email-masked]>
Date: Mon, 12 Jan 2009 05:55:25 +0100

Herbert Xu wrote:
> Patrick McHardy <[email-masked]> wrote:
>>> I've had a look at the dev.c file in 2.6.27, and my very naive guess
>>> is that as the handle_bridge() call is before the handle_macvlan() call,
>>> because the incoming real physical interface is not part of the bridge,
>>> the incoming unicast packet is being dropped, before the macvlan code
>>> gets a look at it.
>> Yes, that seems correct.
> 
> Would it be possible to implement promiscuous mode for macvlans by
> simply keeping a separate list of macvlan devices in promiscuous
> mode and sending all inbound packets to them?
> 
> This should make bridging work, right?

I think that should work, at least if we also put the underlying device
in promiscous mode. It wouldn't really be *mac*vlan anymore though :)

I've put it on my TODO list, though I won't be able to take care
of this any time soon.